*------------------------------------------------------------------------------
*-- Name....: BROWZ.PRG
*-- Date....: 01-31-91
*-- Version.: dBASE IV, v1.1
*-- Notes...: Procedure file for VALID POPUPs where you can specify the needed
*-- ........: variables.
*------------------------------------------------------------------------------
FUNCTION Empty                       && Determine if the passed argument is NULL
  PARAMETER x
  PRIVATE retval, lc_type
  lc_type = TYPE("x")
  DO CASE
    CASE lc_type = "C"
      retval = (LEN(TRIM(x))=0)
    CASE lc_type$"NF"
      retval = (x=0)
    CASE lc_type = "D"
      retval = (" "$DTOC(x))
    OTHERWISE lc_type = "U"
      retval = .T.
  ENDCASE
RETURN (retval)
*-- EOP: _Empty

*------------------------------------------------------------------------------
PROCEDURE _DbfEmpty
   *-- Error box if Lookup .dbf is empty
   *-- Save the screen and setup window
   PRIVATE ALL LIKE l?_*
   DEFINE WINDOW u_error FROM 5,15 TO 11,55
   SAVE SCREEN TO u_error
   DO _Shadowg WITH 5,15,11,55

   *-- Activate the window and put up error message
   ACTIVATE WINDOW u_error
   lc_fpath = SET("fullpath")
   SET FULLPATH OFF
   @ 1,2 SAY "Lookup table: " + SUBSTR( DBF(),3) + " is empty!"
   @ 2,2 SAY "Press any key ..."
   ln_errorky = INKEY(10)

   *-- Restore the screen and clean up
   SET FULLPATH &lc_fpath.
   RELEASE WINDOW u_error
   RESTORE SCREEN FROM u_error
   RELEASE SCREEN u_error
RETURN
*-- EOP: _DbfEmpty

*------------------------------------------------------------------------------
FUNCTION browz
  PARAMETER fld_name,sel1,sel2,x1,x2,y1,y2,Z1,Z2,mfields,mvar,MPIC
  PRIVATE ALL LIKE ??_*
  PRIVATE esckey, ctrlW, tab, fld_name, rtn_fld, sel1, sel2, x1, x2, y1, y2, z1, z2, mfields, mvar, mpic
  PUBLIC RVALUE
  munit = varread()
  ll_return = .T.
  ln_row = ROW()
  ln_col = COL()

  IF EMPTY(fld_name)                   && Not a required field
    RETURN (.T.)                       && if null field
  ENDIF

  EscKey = 27                          && 27 represents the ESC key
  CtrlW  = 23                          && 23 represents the Ctrl-W key
  Tab    = 9                           && 9 represents the Tab key

  SELECT &sel1


  fld_name = IIF( EMPTY( TRIM( fld_name)), fld_name, TRIM( fld_name))
  SEEK fld_name

  IF .NOT. FOUND()
     if fld_name = "EX"
	return (.t.)
     endif
     go top
     DEFINE WINDOW browz FROM x1,x2 to y1,y2
     SAVE SCREEN TO browz


     SET MESSAGE TO [Select:]+CHR(17)+CHR(196)+CHR(217)+[   Cancel:Esc] +;
                    [   To Scroll:]+CHR(24)+[ ]+CHR(25)+[  PgUp  PgDn]

     ON KEY LABEL ctrl-m KEYBOARD( CHR( CtrlW))         && Same as Enter send Ctrl-W

     BROWSE WINDOW browz NOMENU COMPRESS NOFOLLOW NODELETE LOCK 1 ;
        NOAPPEND NOEDIT ;
        FIELDS &mfields

     ON KEY LABEL ctrl-m
     SET MESSAGE TO

     RELEASE WINDOW browz

     RESTORE SCREEN FROM browz


     IF LASTKEY() <> EscKey
       rtn_fld = &mvar

*       IF ln_row = 8 .AND. (ln_col >= 48 .AND. ln_col <= 58 )
          @ Z1,Z2 GET rtn_fld PICTURE "&mpic"
          CLEAR GETS
*       ENDIF

	store rtn_fld to &munit
       ll_return = .T.
     ELSE
       ll_return = .f.

       IF EMPTY(fld_name)             && Not a required field, so return .t.
          ll_return = .f.
       ENDIF

     ENDIF

  ELSE
    ll_return = .t.
  ENDIF

  SELECT &sel2                    && Go back to the edit file

RETURN (ll_return)
*-- EOP: Browz

*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
FUNCTION _numdec
PARAMETER ln_dec
IF ln_dec - INT(ln_dec) > 0
   RETURN .T.
ELSE
   RETURN .F.
ENDIF
*-- EOF: _numdec

*------------------------------------------------------------------------------
FUNCTION Center
*-- UDF to center a string.
*-- lc_string = String to center
*-- ln_width = Width of screen to center in
*--
*-- Ex. @ 15,center(string,80) say string
*-- Will center the <string> withing 80 columns
PARAMETER lc_string, ln_width
RETURN ((ln_width/2)-(LEN(lc_string)/2))
*-- EOP: Center()
